##// END OF EJS Templates
zswap userland sup
Unknown -
r459:816670ca587b
parent child
Show More
@@ -1,448 +1,448
1 1 #
2 2 # Build and Setup RPi2/3 Kernel
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 # Fetch and build latest raspberry kernel
9 9 if [ "$BUILD_KERNEL" = true ] ; then
10 10 # Setup source directory
11 11 mkdir -p "${KERNEL_DIR}"
12 12
13 13 # Copy existing kernel sources into chroot directory
14 14 if [ -n "$KERNELSRC_DIR" ] && [ -d "$KERNELSRC_DIR" ] ; then
15 15 # Copy kernel sources and include hidden files
16 16 cp -r "${KERNELSRC_DIR}/". "${KERNEL_DIR}"
17 17
18 18 # Clean the kernel sources
19 19 if [ "$KERNELSRC_CLEAN" = true ] && [ "$KERNELSRC_PREBUILT" = false ] ; then
20 20 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" mrproper
21 21 fi
22 22 else # KERNELSRC_DIR=""
23 23 # Create temporary directory for kernel sources
24 24 temp_dir=$(as_nobody mktemp -d)
25 25
26 26 # Fetch current RPi2/3 kernel sources
27 27 if [ -z "${KERNEL_BRANCH}" ] ; then
28 28 as_nobody -H git -C "${temp_dir}" clone --depth=1 "${KERNEL_URL}" linux
29 29 else
30 30 as_nobody -H git -C "${temp_dir}" clone --depth=1 --branch "${KERNEL_BRANCH}" "${KERNEL_URL}" linux
31 31 fi
32 32
33 33 # Copy downloaded kernel sources
34 34 cp -r "${temp_dir}/linux/"* "${KERNEL_DIR}"
35 35
36 36 # Remove temporary directory for kernel sources
37 37 rm -fr "${temp_dir}"
38 38
39 39 # Set permissions of the kernel sources
40 40 chown -R root:root "${R}/usr/src"
41 41 fi
42 42
43 43 # Calculate optimal number of kernel building threads
44 44 if [ "$KERNEL_THREADS" = "1" ] && [ -r /proc/cpuinfo ] ; then
45 45 KERNEL_THREADS=$(grep -c processor /proc/cpuinfo)
46 46 fi
47 47
48 48 # Configure and build kernel
49 49 if [ "$KERNELSRC_PREBUILT" = false ] ; then
50 50 # Remove device, network and filesystem drivers from kernel configuration
51 51 if [ "$KERNEL_REDUCE" = true ] ; then
52 52 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" "${KERNEL_DEFCONFIG}"
53 53 sed -i\
54 54 -e "s/\(^CONFIG_SND.*\=\).*/\1n/"\
55 55 -e "s/\(^CONFIG_SOUND.*\=\).*/\1n/"\
56 56 -e "s/\(^CONFIG_AC97.*\=\).*/\1n/"\
57 57 -e "s/\(^CONFIG_VIDEO_.*\=\).*/\1n/"\
58 58 -e "s/\(^CONFIG_MEDIA_TUNER.*\=\).*/\1n/"\
59 59 -e "s/\(^CONFIG_DVB.*\=\)[ym]/\1n/"\
60 60 -e "s/\(^CONFIG_REISERFS.*\=\).*/\1n/"\
61 61 -e "s/\(^CONFIG_JFS.*\=\).*/\1n/"\
62 62 -e "s/\(^CONFIG_XFS.*\=\).*/\1n/"\
63 63 -e "s/\(^CONFIG_GFS2.*\=\).*/\1n/"\
64 64 -e "s/\(^CONFIG_OCFS2.*\=\).*/\1n/"\
65 65 -e "s/\(^CONFIG_BTRFS.*\=\).*/\1n/"\
66 66 -e "s/\(^CONFIG_HFS.*\=\).*/\1n/"\
67 67 -e "s/\(^CONFIG_JFFS2.*\=\)[ym]/\1n/"\
68 68 -e "s/\(^CONFIG_UBIFS.*\=\).*/\1n/"\
69 69 -e "s/\(^CONFIG_SQUASHFS.*\=\)[ym]/\1n/"\
70 70 -e "s/\(^CONFIG_W1.*\=\)[ym]/\1n/"\
71 71 -e "s/\(^CONFIG_HAMRADIO.*\=\).*/\1n/"\
72 72 -e "s/\(^CONFIG_CAN.*\=\).*/\1n/"\
73 73 -e "s/\(^CONFIG_IRDA.*\=\).*/\1n/"\
74 74 -e "s/\(^CONFIG_BT_.*\=\).*/\1n/"\
75 75 -e "s/\(^CONFIG_WIMAX.*\=\)[ym]/\1n/"\
76 76 -e "s/\(^CONFIG_6LOWPAN.*\=\).*/\1n/"\
77 77 -e "s/\(^CONFIG_IEEE802154.*\=\).*/\1n/"\
78 78 -e "s/\(^CONFIG_NFC.*\=\).*/\1n/"\
79 79 -e "s/\(^CONFIG_FB_TFT=.*\=\).*/\1n/"\
80 80 -e "s/\(^CONFIG_TOUCHSCREEN.*\=\).*/\1n/"\
81 81 -e "s/\(^CONFIG_USB_GSPCA_.*\=\).*/\1n/"\
82 82 -e "s/\(^CONFIG_DRM.*\=\).*/\1n/"\
83 83 "${KERNEL_DIR}/.config"
84 84 fi
85 85
86 86 if [ "$KERNELSRC_CONFIG" = true ] ; then
87 87 # Load default raspberry kernel configuration
88 88 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" "${KERNEL_DEFCONFIG}"
89 89
90 90 #Switch to KERNELSRC_DIR so we can use set_kernel_config
91 91 cd "${KERNEL_DIR}" || exit
92 92
93 93 # enable ZSWAP see https://askubuntu.com/a/472227 or https://wiki.archlinux.org/index.php/zswap
94 if [ "$KERNEL_ZSWAP" = true ] && { [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; } ; then
94 if [ "$KERNEL_ZSWAP" = true ] ; then
95 95 set_kernel_config CONFIG_ZPOOL y
96 96 set_kernel_config CONFIG_ZSWAP y
97 97 set_kernel_config CONFIG_ZBUD y
98 98 set_kernel_config CONFIG_Z3FOLD y
99 99 set_kernel_config CONFIG_ZSMALLOC y
100 100 set_kernel_config CONFIG_PGTABLE_MAPPING y
101 101 fi
102 102
103 103 # enable basic KVM support; see https://www.raspberrypi.org/forums/viewtopic.php?f=63&t=210546&start=25#p1300453
104 104 if [ "$KERNEL_VIRT" = true ] && { [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; } ; then
105 105 set_kernel_config CONFIG_VIRTUALIZATION y
106 106 set_kernel_config CONFIG_KVM y
107 107 set_kernel_config CONFIG_VHOST_NET m
108 108 set_kernel_config CONFIG_VHOST_CROSS_ENDIAN_LEGACY y
109 109 fi
110 110
111 111 # Netfilter kernel support See https://github.com/raspberrypi/linux/issues/2177#issuecomment-354647406
112 if [ "$KERNEL_NF" = true ] && { [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; } ; then
112 if [ "$KERNEL_NF" = true ] ; then
113 113 set_kernel_config CONFIG_IP_NF_TARGET_SYNPROXY m
114 114 set_kernel_config CONFIG_NETFILTER_XT_MATCH_CGROUP m
115 115 set_kernel_config CONFIG_NETFILTER_XT_MATCH_IPCOMP m
116 116 set_kernel_config CONFIG_NETFILTER_XT_MATCH_SOCKET m
117 117 set_kernel_config CONFIG_NFT_FIB_INET m
118 118 set_kernel_config CONFIG_NFT_FIB_IPV4 m
119 119 set_kernel_config CONFIG_NFT_FIB_IPV6 m
120 120 set_kernel_config CONFIG_NFT_FIB_NETDEV m
121 121 set_kernel_config CONFIG_NFT_OBJREF m
122 122 set_kernel_config CONFIG_NFT_RT m
123 123 set_kernel_config CONFIG_NFT_SET_BITMAP m
124 124 set_kernel_config CONFIG_NF_CONNTRACK_TIMEOUT y
125 125 set_kernel_config CONFIG_NF_LOG_ARP m
126 126 set_kernel_config CONFIG_NF_SOCKET_IPV4 m
127 127 set_kernel_config CONFIG_NF_SOCKET_IPV6 m
128 128 set_kernel_config CONFIG_BRIDGE_EBT_BROUTE m
129 129 set_kernel_config CONFIG_BRIDGE_EBT_T_FILTER m
130 130 set_kernel_config CONFIG_BRIDGE_NF_EBTABLES m
131 131 set_kernel_config CONFIG_IP6_NF_IPTABLES m
132 132 set_kernel_config CONFIG_IP6_NF_MATCH_AH m
133 133 set_kernel_config CONFIG_IP6_NF_MATCH_EUI64 m
134 134 set_kernel_config CONFIG_IP6_NF_NAT m
135 135 set_kernel_config CONFIG_IP6_NF_TARGET_MASQUERADE m
136 136 set_kernel_config CONFIG_IP6_NF_TARGET_NPT m
137 137 set_kernel_config CONFIG_IP_SET_BITMAP_IPMAC m
138 138 set_kernel_config CONFIG_IP_SET_BITMAP_PORT m
139 139 set_kernel_config CONFIG_IP_SET_HASH_IP m
140 140 set_kernel_config CONFIG_IP_SET_HASH_IPMARK m
141 141 set_kernel_config CONFIG_IP_SET_HASH_IPPORT m
142 142 set_kernel_config CONFIG_IP_SET_HASH_IPPORTIP m
143 143 set_kernel_config CONFIG_IP_SET_HASH_IPPORTNET m
144 144 set_kernel_config CONFIG_IP_SET_HASH_MAC m
145 145 set_kernel_config CONFIG_IP_SET_HASH_NET m
146 146 set_kernel_config CONFIG_IP_SET_HASH_NETIFACE m
147 147 set_kernel_config CONFIG_IP_SET_HASH_NETNET m
148 148 set_kernel_config CONFIG_IP_SET_HASH_NETPORT m
149 149 set_kernel_config CONFIG_IP_SET_HASH_NETPORTNET m
150 150 set_kernel_config CONFIG_IP_SET_LIST_SET m
151 151 set_kernel_config CONFIG_NETFILTER_XTABLES m
152 152 set_kernel_config CONFIG_NETFILTER_XTABLES m
153 153 set_kernel_config CONFIG_NFT_BRIDGE_META m
154 154 set_kernel_config CONFIG_NFT_BRIDGE_REJECT m
155 155 set_kernel_config CONFIG_NFT_CHAIN_NAT_IPV4 m
156 156 set_kernel_config CONFIG_NFT_CHAIN_NAT_IPV6 m
157 157 set_kernel_config CONFIG_NFT_CHAIN_ROUTE_IPV4 m
158 158 set_kernel_config CONFIG_NFT_CHAIN_ROUTE_IPV6 m
159 159 set_kernel_config CONFIG_NFT_COMPAT m
160 160 set_kernel_config CONFIG_NFT_COUNTER m
161 161 set_kernel_config CONFIG_NFT_CT m
162 162 set_kernel_config CONFIG_NFT_DUP_IPV4 m
163 163 set_kernel_config CONFIG_NFT_DUP_IPV6 m
164 164 set_kernel_config CONFIG_NFT_DUP_NETDEV m
165 165 set_kernel_config CONFIG_NFT_EXTHDR m
166 166 set_kernel_config CONFIG_NFT_FWD_NETDEV m
167 167 set_kernel_config CONFIG_NFT_HASH m
168 168 set_kernel_config CONFIG_NFT_LIMIT m
169 169 set_kernel_config CONFIG_NFT_LOG m
170 170 set_kernel_config CONFIG_NFT_MASQ m
171 171 set_kernel_config CONFIG_NFT_MASQ_IPV4 m
172 172 set_kernel_config CONFIG_NFT_MASQ_IPV6 m
173 173 set_kernel_config CONFIG_NFT_META m
174 174 set_kernel_config CONFIG_NFT_NAT m
175 175 set_kernel_config CONFIG_NFT_NUMGEN m
176 176 set_kernel_config CONFIG_NFT_QUEUE m
177 177 set_kernel_config CONFIG_NFT_QUOTA m
178 178 set_kernel_config CONFIG_NFT_REDIR m
179 179 set_kernel_config CONFIG_NFT_REDIR_IPV4 m
180 180 set_kernel_config CONFIG_NFT_REDIR_IPV6 m
181 181 set_kernel_config CONFIG_NFT_REJECT m
182 182 set_kernel_config CONFIG_NFT_REJECT_INET m
183 183 set_kernel_config CONFIG_NFT_REJECT_IPV4 m
184 184 set_kernel_config CONFIG_NFT_REJECT_IPV6 m
185 185 set_kernel_config CONFIG_NFT_SET_HASH m
186 186 set_kernel_config CONFIG_NFT_SET_RBTREE m
187 187 set_kernel_config CONFIG_NF_CONNTRACK_IPV4 m
188 188 set_kernel_config CONFIG_NF_CONNTRACK_IPV6 m
189 189 set_kernel_config CONFIG_NF_DEFRAG_IPV4 m
190 190 set_kernel_config CONFIG_NF_DEFRAG_IPV6 m
191 191 set_kernel_config CONFIG_NF_DUP_IPV4 m
192 192 set_kernel_config CONFIG_NF_DUP_IPV6 m
193 193 set_kernel_config CONFIG_NF_DUP_NETDEV m
194 194 set_kernel_config CONFIG_NF_LOG_BRIDGE m
195 195 set_kernel_config CONFIG_NF_LOG_IPV4 m
196 196 set_kernel_config CONFIG_NF_LOG_IPV6 m
197 197 set_kernel_config CONFIG_NF_NAT_IPV4 m
198 198 set_kernel_config CONFIG_NF_NAT_IPV6 m
199 199 set_kernel_config CONFIG_NF_NAT_MASQUERADE_IPV4 m
200 200 set_kernel_config CONFIG_NF_NAT_MASQUERADE_IPV6 m
201 201 set_kernel_config CONFIG_NF_NAT_PPTP m
202 202 set_kernel_config CONFIG_NF_NAT_PROTO_GRE m
203 203 set_kernel_config CONFIG_NF_NAT_REDIRECT m
204 204 set_kernel_config CONFIG_NF_NAT_SIP m
205 205 set_kernel_config CONFIG_NF_NAT_SNMP_BASIC m
206 206 set_kernel_config CONFIG_NF_NAT_TFTP m
207 207 set_kernel_config CONFIG_NF_REJECT_IPV4 m
208 208 set_kernel_config CONFIG_NF_REJECT_IPV6 m
209 209 set_kernel_config CONFIG_NF_TABLES m
210 210 set_kernel_config CONFIG_NF_TABLES_ARP m
211 211 set_kernel_config CONFIG_NF_TABLES_BRIDGE m
212 212 set_kernel_config CONFIG_NF_TABLES_INET m
213 213 set_kernel_config CONFIG_NF_TABLES_IPV4 m
214 214 set_kernel_config CONFIG_NF_TABLES_IPV6 m
215 215 set_kernel_config CONFIG_NF_TABLES_NETDEV m
216 216 fi
217 217
218 218 # Enables BPF syscall for systemd-journald see https://github.com/torvalds/linux/blob/master/init/Kconfig#L848 or https://groups.google.com/forum/#!topic/linux.gentoo.user/_2aSc_ztGpA
219 if [ "$KERNEL_BPF" = true ] && { [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; } ; then
219 if [ "$KERNEL_BPF" = true ] ; then
220 220 set_kernel_config CONFIG_BPF_SYSCALL y
221 221 set_kernel_config CONFIG_BPF_EVENTS y
222 222 set_kernel_config CONFIG_BPF_STREAM_PARSER y
223 223 set_kernel_config CONFIG_CGROUP_BPF y
224 224 fi
225 225
226 226 # KERNEL_DEFAULT_GOV was set by user
227 227 if ! [ "$KERNEL_DEFAULT_GOV" = POWERSAVE ] && [ -n "$KERNEL_DEFAULT_GOV" ]; then
228 228 # unset default governor
229 229 unset_kernel_config CONFIG_CPU_FREQ_DEFAULT_GOV_POWERSAVE
230 230
231 231 case "$KERNEL_DEFAULT_GOV" in
232 232 "PERFORMANCE")
233 233 set_kernel_config CONFIG_CPU_FREQ_DEFAULT_GOV_PERFORMANCE y
234 234 ;;
235 235 "USERSPACE")
236 236 set_kernel_config CONFIG_CPU_FREQ_DEFAULT_GOV_USERSPACE y
237 237 ;;
238 238 "ONDEMAND")
239 239 set_kernel_config CONFIG_CPU_FREQ_DEFAULT_GOV_ONDEMAND y
240 240 ;;
241 241 "CONSERVATIVE")
242 242 set_kernel_config CONFIG_CPU_FREQ_DEFAULT_GOV_CONSERVATIVE y
243 243 ;;
244 244 "CONSERVATIVE")
245 245 set_kernel_config CONFIG_CPU_FREQ_DEFAULT_GOV_SCHEDUTIL y
246 246 ;;
247 247 *)
248 248 echo "error: unsupported default cpu governor"
249 249 exit 1
250 250 ;;
251 251 esac
252 252 fi
253 253
254 254
255 255
256 256 #Revert to previous directory
257 257 cd "${WORKDIR}" || exit
258 258
259 259 # Set kernel configuration parameters to enable qemu emulation
260 260 if [ "$ENABLE_QEMU" = true ] ; then
261 261 echo "CONFIG_FHANDLE=y" >> "${KERNEL_DIR}"/.config
262 262 echo "CONFIG_LBDAF=y" >> "${KERNEL_DIR}"/.config
263 263
264 264 if [ "$ENABLE_CRYPTFS" = true ] ; then
265 265 {
266 266 echo "CONFIG_EMBEDDED=y"
267 267 echo "CONFIG_EXPERT=y"
268 268 echo "CONFIG_DAX=y"
269 269 echo "CONFIG_MD=y"
270 270 echo "CONFIG_BLK_DEV_MD=y"
271 271 echo "CONFIG_MD_AUTODETECT=y"
272 272 echo "CONFIG_BLK_DEV_DM=y"
273 273 echo "CONFIG_BLK_DEV_DM_BUILTIN=y"
274 274 echo "CONFIG_DM_CRYPT=y"
275 275 echo "CONFIG_CRYPTO_BLKCIPHER=y"
276 276 echo "CONFIG_CRYPTO_CBC=y"
277 277 echo "CONFIG_CRYPTO_XTS=y"
278 278 echo "CONFIG_CRYPTO_SHA512=y"
279 279 echo "CONFIG_CRYPTO_MANAGER=y"
280 280 } >> "${KERNEL_DIR}"/.config
281 281 fi
282 282 fi
283 283
284 284 # Copy custom kernel configuration file
285 285 if [ -n "$KERNELSRC_USRCONFIG" ] ; then
286 286 cp "$KERNELSRC_USRCONFIG" "${KERNEL_DIR}"/.config
287 287 fi
288 288
289 289 # Set kernel configuration parameters to their default values
290 290 if [ "$KERNEL_OLDDEFCONFIG" = true ] ; then
291 291 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" olddefconfig
292 292 fi
293 293
294 294 # Start menu-driven kernel configuration (interactive)
295 295 if [ "$KERNEL_MENUCONFIG" = true ] ; then
296 296 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" menuconfig
297 297 fi
298 298 # end if "$KERNELSRC_CONFIG" = true
299 299 fi
300 300
301 301 # Use ccache to cross compile the kernel
302 302 if [ "$KERNEL_CCACHE" = true ] ; then
303 303 cc="ccache ${CROSS_COMPILE}gcc"
304 304 else
305 305 cc="${CROSS_COMPILE}gcc"
306 306 fi
307 307
308 308 # Cross compile kernel and dtbs
309 309 make -C "${KERNEL_DIR}" -j"${KERNEL_THREADS}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" CC="${cc}" "${KERNEL_BIN_IMAGE}" dtbs
310 310
311 311 # Cross compile kernel modules
312 312 if grep -q "CONFIG_MODULES=y" "${KERNEL_DIR}/.config" ; then
313 313 make -C "${KERNEL_DIR}" -j"${KERNEL_THREADS}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" CC="${cc}" modules
314 314 fi
315 315 # end if "$KERNELSRC_PREBUILT" = false
316 316 fi
317 317
318 318 # Check if kernel compilation was successful
319 319 if [ ! -r "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/${KERNEL_BIN_IMAGE}" ] ; then
320 320 echo "error: kernel compilation failed! (kernel image not found)"
321 321 cleanup
322 322 exit 1
323 323 fi
324 324
325 325 # Install kernel modules
326 326 if [ "$ENABLE_REDUCE" = true ] ; then
327 327 if grep -q "CONFIG_MODULES=y" "${KERNEL_DIR}/.config" ; then
328 328 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" INSTALL_MOD_STRIP=1 INSTALL_MOD_PATH=../../.. modules_install
329 329 fi
330 330 else
331 331 if grep -q "CONFIG_MODULES=y" "${KERNEL_DIR}/.config" ; then
332 332 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" INSTALL_MOD_PATH=../../.. modules_install
333 333 fi
334 334
335 335 # Install kernel firmware
336 336 if grep -q "^firmware_install:" "${KERNEL_DIR}/Makefile" ; then
337 337 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" INSTALL_FW_PATH=../../../lib firmware_install
338 338 fi
339 339 fi
340 340
341 341 # Install kernel headers
342 342 if [ "$KERNEL_HEADERS" = true ] && [ "$KERNEL_REDUCE" = false ] ; then
343 343 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" INSTALL_HDR_PATH=../.. headers_install
344 344 fi
345 345 # make tar.gz kernel package - missing os bzw. modules
346 346 #** ** ** WARNING ** ** **
347 347 #Your architecture did not define any architecture-dependent files
348 348 #to be placed into the tarball. Please add those to ./scripts/package/buildtar .
349 349 # make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" CC="${cc}" targz-pkg
350 350
351 351 # Prepare boot (firmware) directory
352 352 mkdir "${BOOT_DIR}"
353 353
354 354 # Get kernel release version
355 355 KERNEL_VERSION=$(cat "${KERNEL_DIR}/include/config/kernel.release")
356 356
357 357 # Copy kernel configuration file to the boot directory
358 358 install_readonly "${KERNEL_DIR}/.config" "${R}/boot/config-${KERNEL_VERSION}"
359 359
360 360 # Prepare device tree directory
361 361 mkdir "${BOOT_DIR}/overlays"
362 362
363 363 # Ensure the proper .dtb is located
364 364 if [ "$KERNEL_ARCH" = "arm" ] ; then
365 365 for dtb in "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/dts/"*.dtb ; do
366 366 if [ -f "${dtb}" ] ; then
367 367 install_readonly "${dtb}" "${BOOT_DIR}/"
368 368 fi
369 369 done
370 370 else
371 371 for dtb in "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/dts/broadcom/"*.dtb ; do
372 372 if [ -f "${dtb}" ] ; then
373 373 install_readonly "${dtb}" "${BOOT_DIR}/"
374 374 fi
375 375 done
376 376 fi
377 377
378 378 # Copy compiled dtb device tree files
379 379 if [ -d "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/dts/overlays" ] ; then
380 380 for dtb in "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/dts/overlays/"*.dtb ; do
381 381 if [ -f "${dtb}" ] ; then
382 382 install_readonly "${dtb}" "${BOOT_DIR}/overlays/"
383 383 fi
384 384 done
385 385
386 386 if [ -f "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/dts/overlays/README" ] ; then
387 387 install_readonly "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/dts/overlays/README" "${BOOT_DIR}/overlays/README"
388 388 fi
389 389 fi
390 390
391 391 if [ "$ENABLE_UBOOT" = false ] ; then
392 392 # Convert and copy kernel image to the boot directory
393 393 "${KERNEL_DIR}/scripts/mkknlimg" "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/${KERNEL_BIN_IMAGE}" "${BOOT_DIR}/${KERNEL_IMAGE}"
394 394 else
395 395 # Copy kernel image to the boot directory
396 396 install_readonly "${KERNEL_DIR}/arch/${KERNEL_ARCH}/boot/${KERNEL_BIN_IMAGE}" "${BOOT_DIR}/${KERNEL_IMAGE}"
397 397 fi
398 398
399 399 # Remove kernel sources
400 400 if [ "$KERNEL_REMOVESRC" = true ] ; then
401 401 rm -fr "${KERNEL_DIR}"
402 402 else
403 403 # Prepare compiled kernel modules
404 404 if grep -q "CONFIG_MODULES=y" "${KERNEL_DIR}/.config" ; then
405 405 if grep -q "^modules_prepare:" "${KERNEL_DIR}/Makefile" ; then
406 406 make -C "${KERNEL_DIR}" ARCH="${KERNEL_ARCH}" CROSS_COMPILE="${CROSS_COMPILE}" modules_prepare
407 407 fi
408 408
409 409 # Create symlinks for kernel modules
410 410 chroot_exec ln -sf /usr/src/linux "/lib/modules/${KERNEL_VERSION}/build"
411 411 chroot_exec ln -sf /usr/src/linux "/lib/modules/${KERNEL_VERSION}/source"
412 412 fi
413 413 fi
414 414
415 415 else # BUILD_KERNEL=false
416 416 # echo Install precompiled kernel...
417 417 # echo error: not implemented
418 418 if [ "$KERNEL_ARCH" = arm64 ] && { [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; } ; then
419 419 # Create temporary directory for dl
420 420 temp_dir=$(as_nobody mktemp -d)
421 421
422 422 # Fetch kernel dl
423 423 as_nobody wget -O "${temp_dir}"/kernel.tar.xz -c "$RPI3_64_KERNEL_URL"
424 424 #extract download
425 425 tar -xJf "${temp_dir}"/kernel.tar.xz -C "${temp_dir}"
426 426
427 427 #move extracted kernel to /boot/firmware
428 428 mkdir "${R}/boot/firmware"
429 429 cp "${temp_dir}"/boot/* "${R}"/boot/firmware/
430 430 cp -r "${temp_dir}"/lib/* "${R}"/lib/
431 431
432 432 # Remove temporary directory for kernel sources
433 433 rm -fr "${temp_dir}"
434 434 # Set permissions of the kernel sources
435 435 chown -R root:root "${R}/boot/firmware"
436 436 chown -R root:root "${R}/lib/modules"
437 437 #Create cmdline.txt for 15-rpi-config.sh
438 438 touch "${BOOT_DIR}/cmdline.txt"
439 439 fi
440 440
441 441 # Check if kernel installation was successful
442 442 KERNEL="$(ls -1 "${R}"/boot/firmware/kernel* | sort | tail -n 1)"
443 443 if [ -z "$KERNEL" ] ; then
444 444 echo "error: kernel installation failed! (/boot/kernel* not found)"
445 445 cleanup
446 446 exit 1
447 447 fi
448 448 fi
@@ -1,240 +1,268
1 1 #
2 2 # Setup RPi2/3 config and cmdline
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 if [ "$BUILD_KERNEL" = true ] ; then
9 9 if [ -n "$RPI_FIRMWARE_DIR" ] && [ -d "$RPI_FIRMWARE_DIR" ] ; then
10 10 # Install boot binaries from local directory
11 11 cp "${RPI_FIRMWARE_DIR}"/boot/bootcode.bin "${BOOT_DIR}"/bootcode.bin
12 12 cp "${RPI_FIRMWARE_DIR}"/boot/fixup.dat "${BOOT_DIR}"/fixup.dat
13 13 cp "${RPI_FIRMWARE_DIR}"/boot/fixup_cd.dat "${BOOT_DIR}"/fixup_cd.dat
14 14 cp "${RPI_FIRMWARE_DIR}"/boot/fixup_x.dat "${BOOT_DIR}"/fixup_x.dat
15 15 cp "${RPI_FIRMWARE_DIR}"/boot/start.elf "${BOOT_DIR}"/start.elf
16 16 cp "${RPI_FIRMWARE_DIR}"/boot/start_cd.elf "${BOOT_DIR}"/start_cd.elf
17 17 cp "${RPI_FIRMWARE_DIR}"/boot/start_x.elf "${BOOT_DIR}"/start_x.elf
18 18 else
19 19 # Create temporary directory for boot binaries
20 20 temp_dir=$(as_nobody mktemp -d)
21 21
22 22 # Install latest boot binaries from raspberry/firmware github
23 23 as_nobody wget -q -O "${temp_dir}/bootcode.bin" "${FIRMWARE_URL}/bootcode.bin"
24 24 as_nobody wget -q -O "${temp_dir}/fixup.dat" "${FIRMWARE_URL}/fixup.dat"
25 25 as_nobody wget -q -O "${temp_dir}/fixup_cd.dat" "${FIRMWARE_URL}/fixup_cd.dat"
26 26 as_nobody wget -q -O "${temp_dir}/fixup_x.dat" "${FIRMWARE_URL}/fixup_x.dat"
27 27 as_nobody wget -q -O "${temp_dir}/start.elf" "${FIRMWARE_URL}/start.elf"
28 28 as_nobody wget -q -O "${temp_dir}/start_cd.elf" "${FIRMWARE_URL}/start_cd.elf"
29 29 as_nobody wget -q -O "${temp_dir}/start_x.elf" "${FIRMWARE_URL}/start_x.elf"
30 30
31 31 # Move downloaded boot binaries
32 32 mv "${temp_dir}/"* "${BOOT_DIR}/"
33 33
34 34 # Remove temporary directory for boot binaries
35 35 rm -fr "${temp_dir}"
36 36
37 37 # Set permissions of the boot binaries
38 38 chown -R root:root "${BOOT_DIR}"
39 39 chmod -R 600 "${BOOT_DIR}"
40 40 fi
41 41 fi
42 42
43 43 # Setup firmware boot cmdline
44 44 if [ "$ENABLE_UBOOTUSB" = true ] ; then
45 45 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline rootwait console=tty1 init=/bin/systemd"
46 46 else
47 47 if [ "$ENABLE_SPLITFS" = true ] ; then
48 48 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda1 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline rootwait console=tty1 init=/bin/systemd"
49 49 else
50 50 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/mmcblk0p2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline rootwait console=tty1 init=/bin/systemd"
51 51 fi
52 52 fi
53 53
54 54 # Add encrypted root partition to cmdline.txt
55 55 if [ "$ENABLE_CRYPTFS" = true ] ; then
56 56 if [ "$ENABLE_SPLITFS" = true ] ; then
57 57 CMDLINE=$(echo "${CMDLINE}" | sed "s/sda1/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/sda1:${CRYPTFS_MAPPING}/")
58 58 else
59 59 if [ "$ENABLE_UBOOTUSB" = true ] ; then
60 60 CMDLINE=$(echo "${CMDLINE}" | sed "s/sda2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/sda2:${CRYPTFS_MAPPING}/")
61 61 else
62 62 CMDLINE=$(echo "${CMDLINE}" | sed "s/mmcblk0p2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/mmcblk0p2:${CRYPTFS_MAPPING}/")
63 63 fi
64 64 fi
65 65 fi
66 66
67 if [ "$KERNEL_ZSWAP" = true ] ; then
68 # Create temporary directory for systemd-swap sources
69 temp_dir=$(as_nobody mktemp -d)
70
71 # Fetch systemd-swap sources
72 as_nobody git -C "${temp_dir}" clone "${ZSWAP_URL}"
73
74 # Copy downloaded systemd-swap sources
75 mv "${temp_dir}/systemd-swap" "${R}/tmp/"
76
77 # Set permissions of the systemd-swap sources
78 chown -R root:root "${R}/tmp/systemd-swap"
79
80 # Remove temporary directory for systemd-swap sources
81 rm -fr "${temp_dir}"
82
83 # Change into downloaded src dir
84 cd "${R}/tmp/systemd-swap" || exit
85
86 # Build package
87 . ./systemd-swap/package.sh debian
88
89 # Install package
90 chroot_exec dpkg -i /tmp/systemd-swap/systemd-swap-*any.deb
91
92 # Change back into script root dir
93 cd "${WORKDIR}" || exit
94 fi
95
67 96 #locks cpu at max frequency
68 97 if [ "$ENABLE_TURBO" = true ] ; then
69 98 echo "force_turbo=1" >> "${BOOT_DIR}/config.txt"
70 99 # helps to avoid sdcard corruption when force_turbo is enabled.
71 100 echo "boot_delay=1" >> "${BOOT_DIR}/config.txt"
72
73 101 fi
74 102
75 103 if [ "$ENABLE_PRINTK" = true ] ; then
76 104 install_readonly files/sysctl.d/83-rpi-printk.conf "${ETC_DIR}/sysctl.d/83-rpi-printk.conf"
77 105 fi
78 106
79 107 # Install udev rule for serial alias
80 108 install_readonly files/etc/99-com.rules "${LIB_DIR}/udev/rules.d/99-com.rules"
81 109
82 110 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
83 111
84 112 # RPI0,3,3P Use default ttyS0 (mini-UART)as serial interface
85 113 SET_SERIAL="ttyS0"
86 114
87 115 # Bluetooth enabled
88 116 if [ "$ENABLE_BLUETOOTH" = true ] ; then
89 117 # Create temporary directory for Bluetooth sources
90 118 temp_dir=$(as_nobody mktemp -d)
91 119
92 120 # Fetch Bluetooth sources
93 121 as_nobody git -C "${temp_dir}" clone "${BLUETOOTH_URL}"
94 122
95 123 # Copy downloaded sources
96 124 mv "${temp_dir}/pi-bluetooth" "${R}/tmp/"
97 125
98 126 # Bluetooth firmware from arch aur https://aur.archlinux.org/packages/pi-bluetooth/
99 127 as_nobody wget -q -O "${R}/tmp/pi-bluetooth/LICENCE.broadcom_bcm43xx" https://aur.archlinux.org/cgit/aur.git/plain/LICENCE.broadcom_bcm43xx?h=pi-bluetooth
100 128 as_nobody wget -q -O "${R}/tmp/pi-bluetooth/BCM43430A1.hcd" https://aur.archlinux.org/cgit/aur.git/plain/BCM43430A1.hcd?h=pi-bluetooth
101 129
102 130 # Set permissions
103 131 chown -R root:root "${R}/tmp/pi-bluetooth"
104 132
105 133 # Install tools
106 134 install_readonly "${R}/tmp/pi-bluetooth/usr/bin/btuart" "${R}/usr/bin/btuart"
107 135 install_readonly "${R}/tmp/pi-bluetooth/usr/bin/bthelper" "${R}/usr/bin/bthelper"
108 136
109 137 # Install bluetooth udev rule
110 138 install_readonly "${R}/tmp/pi-bluetooth/lib/udev/rules.d/90-pi-bluetooth.rules" "${LIB_DIR}/udev/rules.d/90-pi-bluetooth.rules"
111 139
112 140 # Install Firmware Flash file and apropiate licence
113 141 mkdir -p "$BLUETOOTH_FIRMWARE_DIR"
114 142 install_readonly "${R}/tmp/pi-bluetooth/LICENCE.broadcom_bcm43xx" "${BLUETOOTH_FIRMWARE_DIR}/LICENCE.broadcom_bcm43xx"
115 143 install_readonly "${R}/tmp/pi-bluetooth/BCM43430A1.hcd" "${BLUETOOTH_FIRMWARE_DIR}/LICENCE.broadcom_bcm43xx"
116 144 install_readonly "${R}/tmp/pi-bluetooth/debian/pi-bluetooth.bthelper@.service" "${ETC_DIR}/systemd/system/pi-bluetooth.bthelper@.service"
117 145 install_readonly "${R}/tmp/pi-bluetooth/debian/pi-bluetooth.hciuart.service" "${ETC_DIR}/systemd/system/pi-bluetooth.hciuart.service"
118 146
119 147 # Remove temporary directory
120 148 rm -fr "${temp_dir}"
121 149
122 150 # Switch Pi3 Bluetooth function to use the mini-UART (ttyS0) and restore UART0/ttyAMA0 over GPIOs 14 & 15. Slow Bluetooth and slow cpu. Use /dev/ttyS0 instead of /dev/ttyAMA0
123 151 if [ "$ENABLE_MINIUART_OVERLAY" = true ] ; then
124 152 SET_SERIAL="ttyAMA0"
125 153
126 154 # set overlay to swap ttyAMA0 and ttyS0
127 155 echo "dtoverlay=pi3-miniuart-bt" >> "${BOOT_DIR}/config.txt"
128 156
129 157 # if force_turbo didn't lock cpu at high speed, lock it at low speed (XOR logic) or miniuart will be broken
130 158 if [ "$ENABLE_TURBO" = false ] ; then
131 159 echo "core_freq=250" >> "${BOOT_DIR}/config.txt"
132 160 fi
133 161
134 162 # Activate services
135 163 chroot_exec systemctl enable pi-bluetooth.hciuart.service
136 164 #chroot_exec systemctl enable pi-bluetooth.bthelper@.service
137 165 else
138 166 chroot_exec systemctl enable pi-bluetooth.hciuart.service
139 167 #chroot_exec systemctl enable pi-bluetooth.bthelper@.service
140 168 fi
141 169
142 170 else # if ENABLE_BLUETOOTH = false
143 171 # set overlay to disable bluetooth
144 172 echo "dtoverlay=pi3-disable-bt" >> "${BOOT_DIR}/config.txt"
145 173 fi # ENABLE_BLUETOOTH end
146 174
147 175 else
148 176 # RPI1,1P,2 Use default ttyAMA0 (full UART) as serial interface
149 177 SET_SERIAL="ttyAMA0"
150 178 fi
151 179
152 180 # may need sudo systemctl disable hciuart
153 181 if [ "$ENABLE_CONSOLE" = true ] ; then
154 182 echo "enable_uart=1" >> "${BOOT_DIR}/config.txt"
155 183 # add string to cmdline
156 184 CMDLINE="${CMDLINE} console=serial0,115200"
157 185
158 186 # Enable serial console systemd style
159 187 chroot_exec systemctl enable serial-getty@"$SET_SERIAL".service
160 188 else
161 189 echo "enable_uart=0" >> "${BOOT_DIR}/config.txt"
162 190 # disable serial console systemd style
163 191 chroot_exec systemctl disable serial-getty@"$SET_SERIAL".service
164 192 fi
165 193
166 194 # Remove IPv6 networking support
167 195 if [ "$ENABLE_IPV6" = false ] ; then
168 196 CMDLINE="${CMDLINE} ipv6.disable=1"
169 197 fi
170 198
171 199 # Automatically assign predictable network interface names
172 200 if [ "$ENABLE_IFNAMES" = false ] ; then
173 201 CMDLINE="${CMDLINE} net.ifnames=0"
174 202 else
175 203 CMDLINE="${CMDLINE} net.ifnames=1"
176 204 fi
177 205
178 206 # Install firmware boot cmdline
179 207 echo "${CMDLINE}" > "${BOOT_DIR}/cmdline.txt"
180 208
181 209 # Install firmware config
182 210 install_readonly files/boot/config.txt "${BOOT_DIR}/config.txt"
183 211
184 212 # Setup minimal GPU memory allocation size: 16MB (no X)
185 213 if [ "$ENABLE_MINGPU" = true ] ; then
186 214 echo "gpu_mem=16" >> "${BOOT_DIR}/config.txt"
187 215 fi
188 216
189 217 # Setup boot with initramfs
190 218 if [ "$ENABLE_INITRAMFS" = true ] ; then
191 219 echo "initramfs initramfs-${KERNEL_VERSION} followkernel" >> "${BOOT_DIR}/config.txt"
192 220 fi
193 221
194 222 # Create firmware configuration and cmdline symlinks
195 223 ln -sf firmware/config.txt "${R}/boot/config.txt"
196 224 ln -sf firmware/cmdline.txt "${R}/boot/cmdline.txt"
197 225
198 226 # Install and setup kernel modules to load at boot
199 227 mkdir -p "${LIB_DIR}/modules-load.d/"
200 228 install_readonly files/modules/rpi2.conf "${LIB_DIR}/modules-load.d/rpi2.conf"
201 229
202 230 # Load hardware random module at boot
203 231 if [ "$ENABLE_HWRANDOM" = true ] && [ "$BUILD_KERNEL" = false ] ; then
204 232 sed -i "s/^# bcm2708_rng/bcm2708_rng/" "${LIB_DIR}/modules-load.d/rpi2.conf"
205 233 fi
206 234
207 235 # Load sound module at boot
208 236 if [ "$ENABLE_SOUND" = true ] ; then
209 237 sed -i "s/^# snd_bcm2835/snd_bcm2835/" "${LIB_DIR}/modules-load.d/rpi2.conf"
210 238 else
211 239 echo "dtparam=audio=off" >> "${BOOT_DIR}/config.txt"
212 240 fi
213 241
214 242 # Enable I2C interface
215 243 if [ "$ENABLE_I2C" = true ] ; then
216 244 echo "dtparam=i2c_arm=on" >> "${BOOT_DIR}/config.txt"
217 245 sed -i "s/^# i2c-bcm2708/i2c-bcm2708/" "${LIB_DIR}/modules-load.d/rpi2.conf"
218 246 sed -i "s/^# i2c-dev/i2c-dev/" "${LIB_DIR}/modules-load.d/rpi2.conf"
219 247 fi
220 248
221 249 # Enable SPI interface
222 250 if [ "$ENABLE_SPI" = true ] ; then
223 251 echo "dtparam=spi=on" >> "${BOOT_DIR}/config.txt"
224 252 echo "spi-bcm2708" >> "${LIB_DIR}/modules-load.d/rpi2.conf"
225 253 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]; then
226 254 sed -i "s/spi-bcm2708/spi-bcm2835/" "${LIB_DIR}/modules-load.d/rpi2.conf"
227 255 fi
228 256 fi
229 257
230 258 # Disable RPi2/3 under-voltage warnings
231 259 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
232 260 echo "avoid_warnings=${DISABLE_UNDERVOLT_WARNINGS}" >> "${BOOT_DIR}/config.txt"
233 261 fi
234 262
235 263 # Install kernel modules blacklist
236 264 mkdir -p "${ETC_DIR}/modprobe.d/"
237 265 install_readonly files/modules/raspi-blacklist.conf "${ETC_DIR}/modprobe.d/raspi-blacklist.conf"
238 266
239 267 # Install sysctl.d configuration files
240 268 install_readonly files/sysctl.d/81-rpi-vm.conf "${ETC_DIR}/sysctl.d/81-rpi-vm.conf"
@@ -1,843 +1,845
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for RPi2/3
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=2}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47
48 48 # Kernel Branch
49 49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 50
51 51 # URLs
52 52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 59 #BIS= Kernel has KVM and zswap enabled
60 60 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
61 61 #default bcmrpi3_defconfig target kernel
62 62 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
63 63 #enhanced kernel
64 64 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_BIS_KERNEL_URL}
65 65 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
66 66 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
67 ZSWAP_URL=${ZSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
68
67 69
68 70 # Build directories
69 71 WORKDIR=$(pwd)
70 72 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
71 73 BUILDDIR="${BASEDIR}/build"
72 74
73 75 # Chroot directories
74 76 R="${BUILDDIR}/chroot"
75 77 ETC_DIR="${R}/etc"
76 78 LIB_DIR="${R}/lib"
77 79 BOOT_DIR="${R}/boot/firmware"
78 80 KERNEL_DIR="${R}/usr/src/linux"
79 81 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
80 82 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
81 83
82 84 # Firmware directory: Blank if download from github
83 85 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
84 86
85 87 # General settings
86 88 SET_ARCH=${SET_ARCH:=32}
87 89 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
88 90 PASSWORD=${PASSWORD:=raspberry}
89 91 USER_PASSWORD=${USER_PASSWORD:=raspberry}
90 92 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
91 93 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
92 94 EXPANDROOT=${EXPANDROOT:=true}
93 95
94 96 # Keyboard settings
95 97 XKB_MODEL=${XKB_MODEL:=""}
96 98 XKB_LAYOUT=${XKB_LAYOUT:=""}
97 99 XKB_VARIANT=${XKB_VARIANT:=""}
98 100 XKB_OPTIONS=${XKB_OPTIONS:=""}
99 101
100 102 # Network settings (DHCP)
101 103 ENABLE_DHCP=${ENABLE_DHCP:=true}
102 104
103 105 # Network settings (static)
104 106 NET_ADDRESS=${NET_ADDRESS:=""}
105 107 NET_GATEWAY=${NET_GATEWAY:=""}
106 108 NET_DNS_1=${NET_DNS_1:=""}
107 109 NET_DNS_2=${NET_DNS_2:=""}
108 110 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
109 111 NET_NTP_1=${NET_NTP_1:=""}
110 112 NET_NTP_2=${NET_NTP_2:=""}
111 113
112 114 # APT settings
113 115 APT_PROXY=${APT_PROXY:=""}
114 116 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
115 117
116 118 # Feature settings
117 119 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
118 120 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
119 121 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
120 122 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
121 123 ENABLE_I2C=${ENABLE_I2C:=false}
122 124 ENABLE_SPI=${ENABLE_SPI:=false}
123 125 ENABLE_IPV6=${ENABLE_IPV6:=true}
124 126 ENABLE_SSHD=${ENABLE_SSHD:=true}
125 127 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
126 128 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
127 129 ENABLE_SOUND=${ENABLE_SOUND:=true}
128 130 ENABLE_DBUS=${ENABLE_DBUS:=true}
129 131 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
130 132 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
131 133 ENABLE_XORG=${ENABLE_XORG:=false}
132 134 ENABLE_WM=${ENABLE_WM:=""}
133 135 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
134 136 ENABLE_USER=${ENABLE_USER:=true}
135 137 USER_NAME=${USER_NAME:="pi"}
136 138 ENABLE_ROOT=${ENABLE_ROOT:=false}
137 139 ENABLE_QEMU=${ENABLE_QEMU:=false}
138 140 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
139 141
140 142 # SSH settings
141 143 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
142 144 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
143 145 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
144 146 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
145 147 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
146 148
147 149 # Advanced settings
148 150 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
149 151 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
150 152 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
151 153 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
152 154 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
153 155 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
154 156 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
155 157 ENABLE_NEXMON=${ENABLE_NEXMON:="false"}
156 158 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
157 159 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
158 160 NEXMON_DIR=${NEXMON_DIR:=""}
159 161 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
160 162 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
161 163 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
162 164 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
163 165 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
164 166 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
165 167
166 168 # Kernel compilation settings
167 169 BUILD_KERNEL=${BUILD_KERNEL:=true}
168 170 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
169 171 KERNEL_THREADS=${KERNEL_THREADS:=1}
170 172 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
171 173 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
172 174 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
173 175 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
174 176 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
175 177 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
176 178 KERNEL_VIRT=${KERNEL_VIRT:=false}
177 179 KERNEL_BPF=${KERNEL_BPF:=false}
178 180 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=POWERSAVE}
179 181
180 182 # Kernel compilation from source directory settings
181 183 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
182 184 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
183 185 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
184 186 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
185 187
186 188 # Reduce disk usage settings
187 189 REDUCE_APT=${REDUCE_APT:=true}
188 190 REDUCE_DOC=${REDUCE_DOC:=true}
189 191 REDUCE_MAN=${REDUCE_MAN:=true}
190 192 REDUCE_VIM=${REDUCE_VIM:=false}
191 193 REDUCE_BASH=${REDUCE_BASH:=false}
192 194 REDUCE_HWDB=${REDUCE_HWDB:=true}
193 195 REDUCE_SSHD=${REDUCE_SSHD:=true}
194 196 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
195 197
196 198 # Encrypted filesystem settings
197 199 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
198 200 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
199 201 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
200 202 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
201 203 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
202 204 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
203 205 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
204 206 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
205 207 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
206 208
207 209 # Chroot scripts directory
208 210 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
209 211
210 212 # Packages required in the chroot build environment
211 213 APT_INCLUDES=${APT_INCLUDES:=""}
212 214 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
213 215
214 216 #Packages to exclude from chroot build environment
215 217 APT_EXCLUDES=${APT_EXCLUDES:=""}
216 218
217 219 # Packages required for bootstrapping
218 220 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
219 221 MISSING_PACKAGES=""
220 222
221 223 # Packages installed for c/c++ build environment in chroot (keep empty)
222 224 COMPILER_PACKAGES=""
223 225
224 226 set +x
225 227
226 228 #Check if apt-cacher-ng has port 3142 open and set APT_PROXY
227 229 APT_CACHER_RUNNING=$(lsof -i :3142 | grep apt-cacher-ng | cut -d ' ' -f3 | uniq)
228 230 if [ -n "${APT_CACHER_RUNNING}" ] ; then
229 231 APT_PROXY=http://127.0.0.1:3142/
230 232 fi
231 233
232 234 #netselect-apt does not know buster yet
233 235 if [ "$RELEASE" = "buster" ] ; then
234 236 RLS=testing
235 237 else
236 238 RLS="$RELEASE"
237 239 fi
238 240
239 241 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
240 242 rm "$(pwd)/files/apt/sources.list"
241 243 fi
242 244
243 245 if [ "$ENABLE_NONFREE" = true ] ; then
244 246 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
245 247 else
246 248 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
247 249 fi
248 250
249 251 #sed and cut the result string so we can use it as APT_SERVER
250 252 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
251 253
252 254 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
253 255 if [ -n "$SET_ARCH" ] ; then
254 256 # 64 bit configuration
255 257 if [ "$SET_ARCH" = 64 ] ; then
256 258 # General 64 bit depended settings
257 259 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
258 260 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
259 261 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
260 262
261 263 # Board specific settings
262 264 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
263 265 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
264 266 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
265 267 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
266 268 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
267 269 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
268 270 else
269 271 echo "error: Only Raspberry PI 3 and 3B+ support 64 bit"
270 272 exit 1
271 273 fi
272 274 fi
273 275
274 276 # 32 bit configuration
275 277 if [ "$SET_ARCH" = 32 ] ; then
276 278 # General 32 bit dependend settings
277 279 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
278 280 KERNEL_ARCH=${KERNEL_ARCH:=arm}
279 281 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
280 282
281 283 # Hardware specific settings
282 284 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
283 285 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
284 286 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
285 287 RELEASE_ARCH=${RELEASE_ARCH:=armel}
286 288 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
287 289 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
288 290 fi
289 291
290 292 # Hardware specific settings
291 293 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
292 294 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
293 295 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
294 296 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
295 297 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
296 298 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
297 299 fi
298 300 fi
299 301 #SET_ARCH not set
300 302 else
301 303 echo "error: Please set '32' or '64' as value for SET_ARCH"
302 304 exit 1
303 305 fi
304 306 # Device specific configuration and U-Boot configuration
305 307 case "$RPI_MODEL" in
306 308 0)
307 309 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
308 310 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
309 311 ;;
310 312 1)
311 313 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
312 314 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
313 315 ;;
314 316 1P)
315 317 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
316 318 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
317 319 ;;
318 320 2)
319 321 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
320 322 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
321 323 ;;
322 324 3)
323 325 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
324 326 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
325 327 ;;
326 328 3P)
327 329 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
328 330 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
329 331 ;;
330 332 *)
331 333 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
332 334 exit 1
333 335 ;;
334 336 esac
335 337
336 338 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
337 339 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
338 340 # Include bluetooth packages on supported boards
339 341 if [ "$ENABLE_BLUETOOTH" = true ] && [ "$ENABLE_CONSOLE" = false ]; then
340 342 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
341 343 fi
342 344 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
343 345 # Check if the internal wireless interface is not supported by the RPi model
344 346 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
345 347 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
346 348 exit 1
347 349 fi
348 350 fi
349 351
350 352 # Prepare date string for default image file name
351 353 DATE="$(date +%Y-%m-%d)"
352 354 if [ -z "$KERNEL_BRANCH" ] ; then
353 355 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
354 356 else
355 357 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
356 358 fi
357 359
358 360 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
359 361 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
360 362 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
361 363 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
362 364 exit 1
363 365 fi
364 366 fi
365 367
366 368 # Add cmake to compile videocore sources
367 369 if [ "$ENABLE_VIDEOCORE" = true ] ; then
368 370 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
369 371 fi
370 372
371 373 # Add libncurses5 to enable kernel menuconfig
372 374 if [ "$KERNEL_MENUCONFIG" = true ] ; then
373 375 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
374 376 fi
375 377
376 378 # Add ccache compiler cache for (faster) kernel cross (re)compilation
377 379 if [ "$KERNEL_CCACHE" = true ] ; then
378 380 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
379 381 fi
380 382
381 383 # Add cryptsetup package to enable filesystem encryption
382 384 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
383 385 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
384 386 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
385 387
386 388 #If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
387 389 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
388 390 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
389 391 fi
390 392
391 393 if [ -z "$CRYPTFS_PASSWORD" ] ; then
392 394 echo "error: no password defined (CRYPTFS_PASSWORD)!"
393 395 exit 1
394 396 fi
395 397 ENABLE_INITRAMFS=true
396 398 fi
397 399
398 400 # Add initramfs generation tools
399 401 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
400 402 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
401 403 fi
402 404
403 405 # Add device-tree-compiler required for building the U-Boot bootloader
404 406 if [ "$ENABLE_UBOOT" = true ] ; then
405 407 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
406 408 else
407 409 if [ "$ENABLE_UBOOTUSB" = true ] ; then
408 410 echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
409 411 exit 1
410 412 fi
411 413 fi
412 414
413 415 # Check if root SSH (v2) public key file exists
414 416 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
415 417 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
416 418 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
417 419 exit 1
418 420 fi
419 421 fi
420 422
421 423 # Check if $USER_NAME SSH (v2) public key file exists
422 424 if [ -n "$SSH_USER_PUB_KEY" ] ; then
423 425 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
424 426 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
425 427 exit 1
426 428 fi
427 429 fi
428 430
429 431 # Check if all required packages are installed on the build system
430 432 for package in $REQUIRED_PACKAGES ; do
431 433 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
432 434 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
433 435 fi
434 436 done
435 437
436 438 # If there are missing packages ask confirmation for install, or exit
437 439 if [ -n "$MISSING_PACKAGES" ] ; then
438 440 echo "the following packages needed by this script are not installed:"
439 441 echo "$MISSING_PACKAGES"
440 442
441 443 printf "\ndo you want to install the missing packages right now? [y/n] "
442 444 read -r confirm
443 445 [ "$confirm" != "y" ] && exit 1
444 446
445 447 # Make sure all missing required packages are installed
446 448 apt-get -qq -y install "${MISSING_PACKAGES}"
447 449 fi
448 450
449 451 # Check if ./bootstrap.d directory exists
450 452 if [ ! -d "./bootstrap.d/" ] ; then
451 453 echo "error: './bootstrap.d' required directory not found!"
452 454 exit 1
453 455 fi
454 456
455 457 # Check if ./files directory exists
456 458 if [ ! -d "./files/" ] ; then
457 459 echo "error: './files' required directory not found!"
458 460 exit 1
459 461 fi
460 462
461 463 # Check if specified KERNELSRC_DIR directory exists
462 464 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
463 465 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
464 466 exit 1
465 467 fi
466 468
467 469 # Check if specified UBOOTSRC_DIR directory exists
468 470 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
469 471 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
470 472 exit 1
471 473 fi
472 474
473 475 # Check if specified VIDEOCORESRC_DIR directory exists
474 476 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
475 477 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
476 478 exit 1
477 479 fi
478 480
479 481 # Check if specified FBTURBOSRC_DIR directory exists
480 482 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
481 483 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
482 484 exit 1
483 485 fi
484 486
485 487 # Check if specified NEXMON_DIR directory exists
486 488 if [ -n "$NEXMON_DIR" ] && [ ! -d "$NEXMON_DIR" ] ; then
487 489 echo "error: '${NEXMON_DIR}' specified directory not found (NEXMON_DIR)!"
488 490 exit 1
489 491 fi
490 492
491 493 # Check if specified CHROOT_SCRIPTS directory exists
492 494 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
493 495 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
494 496 exit 1
495 497 fi
496 498
497 499 # Check if specified device mapping already exists (will be used by cryptsetup)
498 500 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
499 501 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
500 502 exit 1
501 503 fi
502 504
503 505 # Don't clobber an old build
504 506 if [ -e "$BUILDDIR" ] ; then
505 507 echo "error: directory ${BUILDDIR} already exists, not proceeding"
506 508 exit 1
507 509 fi
508 510
509 511 # Setup chroot directory
510 512 mkdir -p "${R}"
511 513
512 514 # Check if build directory has enough of free disk space >512MB
513 515 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
514 516 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
515 517 exit 1
516 518 fi
517 519
518 520 set -x
519 521
520 522 # Call "cleanup" function on various signals and errors
521 523 trap cleanup 0 1 2 3 6
522 524
523 525 # Add required packages for the minbase installation
524 526 if [ "$ENABLE_MINBASE" = true ] ; then
525 527 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
526 528 fi
527 529
528 530 # Add parted package, required to get partprobe utility
529 531 if [ "$EXPANDROOT" = true ] ; then
530 532 APT_INCLUDES="${APT_INCLUDES},parted"
531 533 fi
532 534
533 535 # Add dbus package, recommended if using systemd
534 536 if [ "$ENABLE_DBUS" = true ] ; then
535 537 APT_INCLUDES="${APT_INCLUDES},dbus"
536 538 fi
537 539
538 540 # Add iptables IPv4/IPv6 package
539 541 if [ "$ENABLE_IPTABLES" = true ] ; then
540 542 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
541 543 fi
542 544
543 545 # Add openssh server package
544 546 if [ "$ENABLE_SSHD" = true ] ; then
545 547 APT_INCLUDES="${APT_INCLUDES},openssh-server"
546 548 fi
547 549
548 550 # Add alsa-utils package
549 551 if [ "$ENABLE_SOUND" = true ] ; then
550 552 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
551 553 fi
552 554
553 555 # Add rng-tools package
554 556 if [ "$ENABLE_HWRANDOM" = true ] ; then
555 557 APT_INCLUDES="${APT_INCLUDES},rng-tools"
556 558 fi
557 559
558 560 # Add fbturbo video driver
559 561 if [ "$ENABLE_FBTURBO" = true ] ; then
560 562 # Enable xorg package dependencies
561 563 ENABLE_XORG=true
562 564 fi
563 565
564 566 # Add user defined window manager package
565 567 if [ -n "$ENABLE_WM" ] ; then
566 568 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
567 569
568 570 # Enable xorg package dependencies
569 571 ENABLE_XORG=true
570 572 fi
571 573
572 574 # Add xorg package
573 575 if [ "$ENABLE_XORG" = true ] ; then
574 576 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
575 577 fi
576 578
577 579 # Replace selected packages with smaller clones
578 580 if [ "$ENABLE_REDUCE" = true ] ; then
579 581 # Add levee package instead of vim-tiny
580 582 if [ "$REDUCE_VIM" = true ] ; then
581 583 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
582 584 fi
583 585
584 586 # Add dropbear package instead of openssh-server
585 587 if [ "$REDUCE_SSHD" = true ] ; then
586 588 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
587 589 fi
588 590 fi
589 591
590 592 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
591 593 if [ "$ENABLE_SYSVINIT" = false ] ; then
592 594 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
593 595 fi
594 596
595 597 # Configure kernel sources if no KERNELSRC_DIR
596 598 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
597 599 KERNELSRC_CONFIG=true
598 600 fi
599 601
600 602 # Configure reduced kernel
601 603 if [ "$KERNEL_REDUCE" = true ] ; then
602 604 KERNELSRC_CONFIG=false
603 605 fi
604 606
605 607 # Configure qemu compatible kernel
606 608 if [ "$ENABLE_QEMU" = true ] ; then
607 609 DTB_FILE=vexpress-v2p-ca15_a7.dtb
608 610 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
609 611 KERNEL_DEFCONFIG="vexpress_defconfig"
610 612 if [ "$KERNEL_MENUCONFIG" = false ] ; then
611 613 KERNEL_OLDDEFCONFIG=true
612 614 fi
613 615 fi
614 616
615 617 # Execute bootstrap scripts
616 618 for SCRIPT in bootstrap.d/*.sh; do
617 619 head -n 3 "$SCRIPT"
618 620 . "$SCRIPT"
619 621 done
620 622
621 623 ## Execute custom bootstrap scripts
622 624 if [ -d "custom.d" ] ; then
623 625 for SCRIPT in custom.d/*.sh; do
624 626 . "$SCRIPT"
625 627 done
626 628 fi
627 629
628 630 # Execute custom scripts inside the chroot
629 631 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
630 632 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
631 633 chroot_exec /bin/bash -x <<'EOF'
632 634 for SCRIPT in /chroot_scripts/* ; do
633 635 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
634 636 $SCRIPT
635 637 fi
636 638 done
637 639 EOF
638 640 rm -rf "${R}/chroot_scripts"
639 641 fi
640 642
641 643 # Remove c/c++ build environment from the chroot
642 644 chroot_remove_cc
643 645
644 646 # Generate required machine-id
645 647 MACHINE_ID=$(dbus-uuidgen)
646 648 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
647 649 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
648 650
649 651 # APT Cleanup
650 652 chroot_exec apt-get -y clean
651 653 chroot_exec apt-get -y autoclean
652 654 chroot_exec apt-get -y autoremove
653 655
654 656 # Unmount mounted filesystems
655 657 umount -l "${R}/proc"
656 658 umount -l "${R}/sys"
657 659
658 660 # Clean up directories
659 661 rm -rf "${R}/run/*"
660 662 rm -rf "${R}/tmp/*"
661 663
662 664 # Clean up files
663 665 rm -f "${ETC_DIR}/ssh/ssh_host_*"
664 666 rm -f "${ETC_DIR}/dropbear/dropbear_*"
665 667 rm -f "${ETC_DIR}/apt/sources.list.save"
666 668 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
667 669 rm -f "${ETC_DIR}/*-"
668 670 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
669 671 rm -f "${ETC_DIR}/resolv.conf"
670 672 rm -f "${R}/root/.bash_history"
671 673 rm -f "${R}/var/lib/urandom/random-seed"
672 674 rm -f "${R}/initrd.img"
673 675 rm -f "${R}/vmlinuz"
674 676 rm -f "${R}${QEMU_BINARY}"
675 677
676 678 if [ "$ENABLE_QEMU" = true ] ; then
677 679 # Setup QEMU directory
678 680 mkdir "${BASEDIR}/qemu"
679 681
680 682 # Copy kernel image to QEMU directory
681 683 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
682 684
683 685 # Copy kernel config to QEMU directory
684 686 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
685 687
686 688 # Copy kernel dtbs to QEMU directory
687 689 for dtb in "${BOOT_DIR}/"*.dtb ; do
688 690 if [ -f "${dtb}" ] ; then
689 691 install_readonly "${dtb}" "${BASEDIR}/qemu/"
690 692 fi
691 693 done
692 694
693 695 # Copy kernel overlays to QEMU directory
694 696 if [ -d "${BOOT_DIR}/overlays" ] ; then
695 697 # Setup overlays dtbs directory
696 698 mkdir "${BASEDIR}/qemu/overlays"
697 699
698 700 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
699 701 if [ -f "${dtb}" ] ; then
700 702 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
701 703 fi
702 704 done
703 705 fi
704 706
705 707 # Copy u-boot files to QEMU directory
706 708 if [ "$ENABLE_UBOOT" = true ] ; then
707 709 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
708 710 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
709 711 fi
710 712 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
711 713 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
712 714 fi
713 715 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
714 716 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
715 717 fi
716 718 fi
717 719
718 720 # Copy initramfs to QEMU directory
719 721 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
720 722 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
721 723 fi
722 724 fi
723 725
724 726 # Calculate size of the chroot directory in KB
725 727 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
726 728
727 729 # Calculate the amount of needed 512 Byte sectors
728 730 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
729 731 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
730 732 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
731 733
732 734 # The root partition is EXT4
733 735 # This means more space than the actual used space of the chroot is used.
734 736 # As overhead for journaling and reserved blocks 35% are added.
735 737 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
736 738
737 739 # Calculate required image size in 512 Byte sectors
738 740 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
739 741
740 742 # Prepare image file
741 743 if [ "$ENABLE_SPLITFS" = true ] ; then
742 744 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
743 745 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
744 746 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
745 747 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
746 748
747 749 # Write firmware/boot partition tables
748 750 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
749 751 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
750 752 EOM
751 753
752 754 # Write root partition table
753 755 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
754 756 ${TABLE_SECTORS},${ROOT_SECTORS},83
755 757 EOM
756 758
757 759 # Setup temporary loop devices
758 760 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
759 761 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
760 762 else # ENABLE_SPLITFS=false
761 763 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
762 764 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
763 765
764 766 # Write partition table
765 767 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
766 768 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
767 769 ${ROOT_OFFSET},${ROOT_SECTORS},83
768 770 EOM
769 771
770 772 # Setup temporary loop devices
771 773 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
772 774 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
773 775 fi
774 776
775 777 if [ "$ENABLE_CRYPTFS" = true ] ; then
776 778 # Create dummy ext4 fs
777 779 mkfs.ext4 "$ROOT_LOOP"
778 780
779 781 # Setup password keyfile
780 782 touch .password
781 783 chmod 600 .password
782 784 echo -n ${CRYPTFS_PASSWORD} > .password
783 785
784 786 # Initialize encrypted partition
785 787 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
786 788
787 789 # Open encrypted partition and setup mapping
788 790 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
789 791
790 792 # Secure delete password keyfile
791 793 shred -zu .password
792 794
793 795 # Update temporary loop device
794 796 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
795 797
796 798 # Wipe encrypted partition (encryption cipher is used for randomness)
797 799 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
798 800 fi
799 801
800 802 # Build filesystems
801 803 mkfs.vfat "$FRMW_LOOP"
802 804 mkfs.ext4 "$ROOT_LOOP"
803 805
804 806 # Mount the temporary loop devices
805 807 mkdir -p "$BUILDDIR/mount"
806 808 mount "$ROOT_LOOP" "$BUILDDIR/mount"
807 809
808 810 mkdir -p "$BUILDDIR/mount/boot/firmware"
809 811 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
810 812
811 813 # Copy all files from the chroot to the loop device mount point directory
812 814 rsync -a "${R}/" "$BUILDDIR/mount/"
813 815
814 816 # Unmount all temporary loop devices and mount points
815 817 cleanup
816 818
817 819 # Create block map file(s) of image(s)
818 820 if [ "$ENABLE_SPLITFS" = true ] ; then
819 821 # Create block map files for "bmaptool"
820 822 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
821 823 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
822 824
823 825 # Image was successfully created
824 826 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
825 827 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
826 828 else
827 829 # Create block map file for "bmaptool"
828 830 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
829 831
830 832 # Image was successfully created
831 833 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
832 834
833 835 # Create qemu qcow2 image
834 836 if [ "$ENABLE_QEMU" = true ] ; then
835 837 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
836 838 QEMU_SIZE=16G
837 839
838 840 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
839 841 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
840 842
841 843 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
842 844 fi
843 845 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant